
#include "kernel.h"

void init_shm(void)
{
  int i;

  for( i=0; i<MAX_IPC; i++ ) {
    all_h[i].id=UNDEF;
    //all_h[i].size=0;
    //all_h[i].pid=UNDEF;
  }
}

addr_t ipc_shmget( struct syscall *message, int index )
{
  int i,b,s;
  
  b = message->arg2;
  s = message->arg3;

  if ( message->arg1 < 1 ) return IPCERR_INVALIDID;

  for( i=0; i<MAX_IPC; i++ ) {
    if ( message->arg1 == all_h[i].id ) {
      if ( message->arg4 & IPC_EX ) return IPCERR_EXISTS;
      return all_h[i].base;
    }
  }
  
  for( i=0; i<MAX_IPC; i++ ) {
    if ( all_h[i].id == UNDEF ) continue;
    if ( (b >= all_h[i].base || b+s >= all_h[i].base ) &&
         (b <= all_h[i].base+all_h[i].size ||
          b+s <= all_h[i].base+all_h[i].size) )
      return IPCERR_MEMUSED;
  }

  for( i=0; i<=MAX_IPC; i++ ) {
    if ( i == MAX_IPC ) {
      return UNDEF;
    }
    if ( all_h[i].id == UNDEF ) break; // nasli sme volny
  }
  
  all_h[i].id = message->arg1;
  all_h[i].base = b;
  all_h[i].size = s;
  all_h[i].pid = all_p[index].pid;

  return b;
}

int ipc_shmdestroy( struct syscall *message, int index )
{
  int i,j;
  
  j = UNDEF;
  for( i=0; i<MAX_IPC; i++ ) {
    if ( message->arg1 == all_h[i].id ) {
      j = i;
      break;
    }
  }
  
  if ( j == UNDEF ) return IPCERR_INVALIDID;

  if ( all_h[j].pid != all_p[index].pid ) return ENOPERM;

  all_h[j].id = UNDEF;

  unmap( all_h[j].base, all_h[j].size );

  return 0;
}
