#include "kernel.h"

void init_sched()
{
  int i;

  for (i=0;i<MAX_PROCESS;i++)
    {
      all_p[i].priority = 0;
    }

}

int kp1 (sid_t s, int op) {
  scheduler_message_t message;
  int i,j;
	
  switch (op) {
  case IPC_SEND:
    receive (s, (addr_t) &message, sizeof(message));

    i=socket2index(s,1);
	
    all_p[i].priority = message.arg1;
    all_p[i].time_c += message.arg1;
	
    for (j=0;j<MAX_PAGES;j++)
      if (pages[j].base!=UNDEF && pages[j].owner==i) pages[j].priority+= message.arg1;
    
		
    if (i!=UNDEF) {
      switch (message.event) {
      case KP1_PROCESS_BLOCKED:
	all_p[i].state=P_BLOCKED;
	break;
      case KP1_PROCESS_RESUMED:
      case KP1_PROCESS_STOPPED:
	all_p[i].state=P_READY;
	break;
      default:
      }
    } else { 
      quantum (s, IPC_SEND, 0);
      issue(s,0,0,IPC_NOOP, IPC_VOID, 0);
    }
  }
  return 1;  
}


void schedule()
{
  int i,min;
  int index=-1;

  //Vyberieme proces s najvacsiou prioritou, ktory sa ma naschedulovat
  //t.j. ma nastaveny P_READY
  min=QUANTUM;

/*   for(i=0; i<MAX_PROCESS;i++) { */
/*     if ( all_p[i].pid != UNDEF ) { */
/*       print_s("SCHED: Proces s pid = ");print_i(all_p[i].pid); */
/*       printf("priority: ",all_p[i].priority); */
/*       printf("state: ",all_p[i].state); */
/*     } */
/*   } */

  for (i=0;i<MAX_PROCESS;i++)
    {
    if (all_p[i].pid!=UNDEF && all_p[i].state == P_READY) { index=i; break; }
    }
  if (index==-1) return;


  for (i=0;i<MAX_PROCESS; i++)
    if ( all_p[i].pid !=UNDEF && all_p[i].state == P_READY && min>all_p[i].priority) { 
      min=all_p[i].priority; index=i;
    }

  //print_s("Spusteny proces: "); print_i(index);
  all_p[index].state=P_RUNNING;
  quantum (all_p[index].sockets[1],IPC_SEND,QUANTUM);
  issue(all_p[index].sockets[1],0,0,IPC_NOOP, IPC_VOID,0);
  //print_s("ok\n");

  for (i=0;i<MAX_PROCESS; i++)
    {
      if (all_p[i].pid !=UNDEF) all_p[i].priority/=2;
      //      print_s("Proces "); print_i(i); print_s(" priorita: "); print_i(all_p[i].priority); print_s("\n");
    }
}
